#include <Blynk.h>

#include <WiFi.h>       //connect through WiFi
#include <WiFiClient.h>    //connect through WiFi
#include <BlynkSimpleEsp32.h>    //connect through WiFi


//#include <BlynkSimpleEsp32_BLE.h>   //connect through BLE
//#include <BLEDevice.h>      //connect through BLE
//#include <BLEServer.h>      //connect through BLE

#define BLYNK_USE_DIRECT_CONNECT

//
#include <Wire.h>           //communicate with I2C
//#include <Adafruit_MPU6050.h>
//#include <Adafruit_Sensor.h>
//#include "Adafruit_DRV2605.h"

#define BLYNK_PRINT Serial




int pinLED = 15;     //GPIO pin for LED
// Adafruit_MPU6050 mpu;     //define the accelerometer/gyroscope module (MPU6050)
// Adafruit_DRV2605 drv;     //define the haptic feedback module (DRV2605)

const int MPU_addr=0x68;
int16_t AcX,AcY,AcZ,Tmp,GyX,GyY,GyZ;
 
int minVal=265;
int maxVal=402;
 
double x;
double y;
double z;


char auth[] = "lmkzsZL8UID1OzKjS30XY_KijGfIoQYc";  //WiFi authorization code
char ssid[] = "TP-LINK_254C";
char pass[] = "2318231988";

//char auth[] = "h_zTn-I790YuzLxT7ldgKLLRIueXlq1e";  //BLE authorization code



void setup() {  
  pinMode(pinLED, OUTPUT); 
  pinMode(pinLED, HIGH);

  Serial.begin(115200);
  delay(10);
  Blynk.begin(auth, ssid, pass);  //verify WiFi connection

  //Serial.println("Waiting for connections...");   //verify BT connection
  //Blynk.setDeviceName("Blynk");
  //Blynk.begin(auth);

  Wire.begin();
  Wire.beginTransmission(MPU_addr);
  Wire.write(0x6B);
  Wire.write(0);
  Wire.endTransmission(true);
}


void loop(){
    Blynk.run();

    Wire.beginTransmission(MPU_addr);
    Wire.write(0x3B);
    Wire.endTransmission(false);
    Wire.requestFrom(MPU_addr,14,true);
    AcX=Wire.read()<<8|Wire.read();
    AcY=Wire.read()<<8|Wire.read();
    AcZ=Wire.read()<<8|Wire.read();
    
    int xAng = map(AcX,minVal,maxVal,-90,90);
    int yAng = map(AcY,minVal,maxVal,-90,90);
    int zAng = map(AcZ,minVal,maxVal,-90,90);
    
    x= RAD_TO_DEG * (atan2(-yAng, -zAng)+PI);
    y= RAD_TO_DEG * (atan2(-xAng, -zAng)+PI);
    z= RAD_TO_DEG * (atan2(-yAng, -xAng)+PI);
    
    Serial.print("AngleX= ");
    Serial.println(x);
    
    Serial.print("AngleY= ");
    Serial.println(y);
    
    Serial.print("AngleZ= ");
    Serial.println(z);
    Serial.println("-----------------------------------------");
    
    Blynk.virtualWrite(V2, x);
    Blynk.virtualWrite(V3, y);
    Blynk.virtualWrite(V4, z);
    
    delay(1000);
}
